
#include <inttypes.h>

#include <util/delay_basic.h>

static inline void delay_us(uint8_t __us) __attribute__((always_inline));
static inline void delay_10us(uint8_t __us10) __attribute__((always_inline));
static inline void delay_ms(uint8_t __ms) __attribute__((always_inline));
static inline void delay_s(uint8_t __ms) __attribute__((always_inline));


// Define number of counts per time period using _delay_loop_2
#define MS_COUNT2 F_CPU / 4000
#define US10_COUNT2 F_CPU / 400000
#define US_COUNT2 F_CPU / 4000000


void delay_us(uint8_t __us)
{
	_delay_loop_2(US_COUNT2 * __us);
}


void delay_10us(uint8_t __us10)
{
	_delay_loop_2(US10_COUNT2 * __us10);
}


void delay_ms(uint8_t __ms)
{
	uint8_t __ticks;

	for(__ticks=0;__ticks<__ms;__ticks++)
	{
		_delay_loop_2(MS_COUNT2);
	}
}


void delay_s(uint8_t __s)
{
	uint8_t __ticks;

	for(__ticks=0; __ticks<__s; __ticks++)
	{
		delay_ms(250);
		delay_ms(250);
		delay_ms(250);
		delay_ms(250);
	}
}

